#include "ProjectionModel.h"
#include "gui/QChannelManagerWidget.h"
#include "gui/QChannelWidget.h"
#include "gui/QScreenWidget.h"
#include "gui/QSceneWidget.h"
#include "gui/QPanelWidget.h"

using namespace projection;

QPanelWidget::QPanelWidget(QWidget* pParent, Qt::WFlags flags)
    : QWidget(pParent, flags)
{
    ui.setupUi(this);

    m_pModel = NULL;
}

QPanelWidget::~QPanelWidget()
{
}

void QPanelWidget::setModel(ProjectionModel* pModel)
{
    m_pModel = pModel;

    ui.channelManager->setModel(m_pModel);
    ui.screen->setScreen(m_pModel->getScreen());
    ui.scene->setScene(m_pModel->getScene());

    updateGUI();
}

void QPanelWidget::selectChannel(Channel* pChannel)
{
    if (ui.channelManager->getSelectedChannel() != m_pModel->getChannelIndex(pChannel))
        ui.channelManager->selectChannel(m_pModel->getChannelIndex(pChannel));
    if (ui.channel->getChannel() != pChannel) {
        ui.channel->setChannel(pChannel);
        ui.channel->updateGUI();
    }
}

void QPanelWidget::activateChannels()
{
    ui.tabWidget->setCurrentIndex(0);
}

void QPanelWidget::activateScreen()
{
    ui.tabWidget->setCurrentIndex(1);
}

void QPanelWidget::activateScene()
{
    ui.tabWidget->setCurrentIndex(2);
}

void QPanelWidget::updateChannelNames()
{
    ui.channelManager->updateChannelNamesGUI();
}

void QPanelWidget::updateChannels()
{
    ui.channelManager->updateGUI();
}

void QPanelWidget::updateCurrentChannel()
{
    ui.channel->updateGUI();
}

void QPanelWidget::updateGUI()
{
    ui.channelManager->updateGUI();
    ui.channel->updateGUI();
    ui.screen->updateGUI();
    ui.scene->updateGUI();
}
